// Copyright 2017 Istio Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// THIS FILE IS AUTOMATICALLY GENERATED.

package sampleapa

import (
	"context"
	"net"
	"time"

	"istio.io/istio/mixer/pkg/adapter"
)

// Fully qualified name of the template
const TemplateName = "sampleapa"

// Instance is constructed by Mixer for the 'sampleapa' template.
type Instance struct {
	// Name of the instance as specified in configuration.
	Name string

	Int64Primitive int64

	BoolPrimitive bool

	DoublePrimitive float64

	StringPrimitive string
}

// Output struct is returned by the attribute producing adapters that handle this template.
type Output struct {
	fieldsSet map[string]bool

	Int64Primitive int64

	BoolPrimitive bool

	DoublePrimitive float64

	StringPrimitive string

	StringMap map[string]string

	Ip net.IP

	Duration time.Duration

	Timestamp time.Time

	Dns adapter.DNSName
}

func NewOutput() *Output {
	return &Output{fieldsSet: make(map[string]bool)}
}

func (o *Output) SetInt64Primitive(val int64) {
	o.fieldsSet["int64Primitive"] = true
	o.Int64Primitive = val
}

func (o *Output) SetBoolPrimitive(val bool) {
	o.fieldsSet["boolPrimitive"] = true
	o.BoolPrimitive = val
}

func (o *Output) SetDoublePrimitive(val float64) {
	o.fieldsSet["doublePrimitive"] = true
	o.DoublePrimitive = val
}

func (o *Output) SetStringPrimitive(val string) {
	o.fieldsSet["stringPrimitive"] = true
	o.StringPrimitive = val
}

func (o *Output) SetStringMap(val map[string]string) {
	o.fieldsSet["stringMap"] = true
	o.StringMap = val
}

func (o *Output) SetIp(val net.IP) {
	o.fieldsSet["ip"] = true
	o.Ip = val
}

func (o *Output) SetDuration(val time.Duration) {
	o.fieldsSet["duration"] = true
	o.Duration = val
}

func (o *Output) SetTimestamp(val time.Time) {
	o.fieldsSet["timestamp"] = true
	o.Timestamp = val
}

func (o *Output) SetDns(val adapter.DNSName) {
	o.fieldsSet["dns"] = true
	o.Dns = val
}

func (o *Output) WasSet(field string) bool {
	_, found := o.fieldsSet[field]
	return found
}

// HandlerBuilder must be implemented by adapters if they want to
// process data associated with the 'sampleapa' template.
//
// Mixer uses this interface to call into the adapter at configuration time to configure
// it with adapter-specific configuration as well as all template-specific type information.
type HandlerBuilder interface {
	adapter.HandlerBuilder
}

// Handler must be implemented by adapter code if it wants to
// process data associated with the 'sampleapa' template.
//
// Mixer uses this interface to call into the adapter at request time in order to dispatch
// created instances to the adapter. Adapters take the incoming instances and do what they
// need to achieve their primary function.
type Handler interface {
	adapter.Handler

	// HandleSampleApa is called by Mixer at request time to deliver instances to
	// to an adapter.
	GenerateSampleApaAttributes(context.Context, *Instance) (*Output, error)
}
